'****************************************************************
'*  Name    : Test1_WatchdogInt.BAS                             *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 14/05/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : testing the "Watchdog_DebounceA.inc" library      *
'*          : Timing 4 mS                                       *
'*  Code powered by the Proton Development Suite Version 3583   *
'****************************************************************
'
'
'===============================================================================
' This program is free software, you can redistribute it and/or modify.
' The code is offered as-is and the author take any responsibility for its use.
' This program is distributed in the hope that it will be useful, but WITHOUT ANY
' WARRANTY. However, a mention of the author and compiler would be appreciated.
'
' Este programa es un software libre, puede redistribuirlo y/o modificarlo.
' Se entrega este cdigo tal como esta y el autor NO se hace responsable de
' su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.

' Ce programme est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' Ce logiciel est offert tel qu'il est, et son auteur NE prend AUCUNE responsabilit
' pour son utilization. Ce programme est distribu dans l'espoir qu'il sera util,
' mais SANS AUCUNE GARANTIE. Cependant mentionner l'auteur et le compileur serait
' aprci.
'===============================================================================
'===============================================================================
' Uncomment this line to run the code with Proteus.
    $define _ProteusDebug_

' Uncomment this line to enable the WatchDog.
    $define WatchDog_On

' Uncomment this line to test the WatchDog (disable the "Clrwdt" in the interrupt delay).
'    $define _TestWatchDogReset_

' Uncomment this line to use the oscilloscope to see the interrupt pulses. (only for this demo).
'    $define _DebugInterrupt_
                                                                             
'===============================================================================
    Include "Amicus18_25k20_WDT.inc"

'    Include "Amicus18_25k22_WDT.Inc"
'-------------------------------------------------------------------------------
' The compiler does not include "Clrwdt" in the command codes.
' The "Clrwdt" must to be managed by the user in the main code only.
    Declare Watchdog = OFF
    Declare Bootloader = On     ' goto proton#main#start, position error?????
'-------------------------------------------------------------------------------
    $if _device = _18F25K20
'    Include "D:\MyIncFiles\SYS_18Fxxk20.inc"
    Include "SYS_18Fxxk20.inc"
    $endif
    $if _device = _18F25K22
'    Include "D:\MyIncFiles\SYS_18F2X-4xk22.inc"
    Include "SYS_18F2X-4xk22.Inc"
    $endif
'-------------------------------------------------------------------------------
' Pins definitions of the project.
'    Include "D:\MyIncFiles\Project1_Declare.lpb"
    Include "Project001_Def.lpb"
'-------------------------------------------------------------------------------
' Include the new library for Debounce and Watchdog.   
'    Include "D:\MyIncFiles\Watchdog_DebounceA.Inc"
    Include "Watchdog_DebounceA.inc"
'===============================================================================
'*******************************************************************************    
' Declare variables fot main code.
    Dim LoopCounter As Byte

'*******************************************************************************    
MAIN_TEST:
    ' INTERRUPTS DISABLED:
    ' The watchdog timer is set to 256mS by Config Fuses and running.
    ' Delay 1 second to start the project.
    ' It is the way to write a large delay when the Interrupts are not enabled yet.
    LoopCounter = 10            ' Load a 0,5 second delay.
    Repeat
        $ifdef WatchDog_On
        Clrwdt
        $endif
        Dec LoopCounter
        DelayMS 50              ' The Watchdog timer is running with a 256mS delay (configured in the Config Fuses).
    Until LoopCounter = 0
'-------------------------------------------------------------------------------
    ' INTERRUPTS DISABLED:
    INTCON2 = %10000000     ' PORTB Pullups disabled
    INTCON3 = 0
    PIR2 = 0
    PIE2 = 0
    IPR2 = 0                    
'
' Declare all digital   
    ADCON0 = 0
    ADCON1 = 15
    ADCON2 = 0    
    CM1CON0 = 0
    CM2CON0 = 0
    CM2CON1 = 0    
' The ANSEL pins are managed by the library.
'    ANSEL = 0
'    ANSELH = 0
'
' Init the eeprom
    EECON1 = 0
'
' Init the PORTS
    LED0 = 0
    LED1 = 0 
    LED2 = 0
    LED3 = 0
    LED4 = 0
    LED5 = 0 
    LED6 = 0
    LED7 = 0       

' Pin for test.
    $ifdef _DebugInterrupt_
    $if _device = _18F25K20
    ANSEL.4 = 0             ' Test pin to digital for PORTA.5
    $endif
    $if _device = _18F25K22
    ANSELA.4 = 0            ' Test pin to digital for PORTA.5
    ANSELC.5 = 0            ' Test pin to digital for PORTC.5
    $endif    
    Output OutTest          ' Test pin to output.
    Output OutTest1         ' Test pin to output.
    $endif
'-------------------------------------------------------------------------------
    ' INTERRUPTS DISABLED:
    ' Send all version files to the terminal.
    $ifdef _HRSOutVersionFile_inc_
    $ifdef WatchDog_On
    Clrwdt
    $endif
    HRSOut CR
    HRSOutVersionFile(_Project_Def_lpb_Version_)        ' Project001_Def.lpb
    HRSOutVersionFile(_Watchdog_Debounce_inc_Version_)  ' Library .inc.
    HRSOutVersionFile(_Test1_WatchdogInt_bas_Version_)  ' Test main code .bas.
    $endif

    $if _device = _18F25K20
    HRSOut "Device: PIC18F25K20", CR
    $endif
    $if _device = _18F25K22
    HRSOut "Device: PIC18F25K22", CR
    $endif
    HRSOut CR  
'-------------------------------------------------------------------------------
STARTING_TEST:
    ' INTERRUPTS DISABLED:
    ' Declare the debounce timing by the user: example 20 => reading the inputs every 20mS.
    ' Stable readings after 20 mS x 4 samples = 80 mS.
    ' The value must to be a multiple of 4. Example: 4,8,12,16,20,24,28,32,36,40,44,48,52,56, etc...
    '
    InitDebounceRate(20)
    ' INTERRUPTS ENABLED:
    ' Debouncing the buttons at 20mS x 4 samples = 80 mS
    ' After this command the Interrupts are started.

    HRSOut "New WATCHDOG by A. Freixanet", CR
    HRSOut "Debounce 8 Buttons and run the new WATCHDOG", CR   

    ' Read the the watchdog counter and print it.
    $ifdef WatchDog_On
    DataWord = ERead ADD_WDT_COUNTER
    HRSOut "WDT COUNTER: ", Dec DataWord, CR
    $endif

    HRSOut "THE FOSC IS ", Dec _xtal, " Mhz", CR, CR
    HRSOut "PRESS SW0 BUTTON TO BEGIN", CR, CR
    '---------------------------------------------------------------------------
    ' INTERRUPTS ENABLED:
    ' Waiting to press the SW0 button to continue.
    While 1 = 1
        If SW0_Fedge = 1 Then
            SW0_Fedge = 0                       ' Clear the bit when it is already read.
            HRSOut "STARTING THE TEST", CR
            HRSOut "PRESS A BUTTON...", CR
            While SW0 = 0
                $ifdef WatchDog_On
                Clrwdt
                $endif
                DelayMS 20                      ' 20mS PDS delay
            Wend
            HRSOut CR
            Break
        EndIf
        ' Without the delay enable these lines
        '$ifdef WatchDog_On
        'Clrwdt
        '$endif
        MyDelayMS(40)                           ' 40mS delay.  The Delay must be multiple of 4mS.
    Wend
    '
    '---------------------------------------------------------------------------
    ' Running the main code.
    ' INTERRUPTS ENABLED:
    While 1 = 1
        ' Without the delay enable these lines
        '$ifdef WatchDog_On
        'Clrwdt
        '$endif

        ' Check all buttons pressed.
        ' Resistors pull-up to VDD
'        If SW0 = 0 Then
'            HRSOut "SW0 pressed!", CR    
'        EndIf
'        If SW1 = 0 Then
'            HRSOut "SW1 pressed!", CR    
'        EndIf    
'        If SW2 = 0 Then
'            HRSOut "SW2 pressed!", CR    
'        EndIf    
'        If SW3 = 0 Then
'            HRSOut "SW3 pressed!", CR    
'        EndIf    
        '
        ' Resistors pull-up To VSS
'        If SW4 = 1 Then
'            HRSOut "SW4 pressed!", CR    
'        EndIf
'        If SW5 = 1 Then
'            HRSOut "SW5 pressed!", CR    
'        EndIf    
'        If SW6 = 1 Then
'            HRSOut "SW6 pressed!", CR    
'        EndIf    
'        If SW7 = 1 Then
'            HRSOut "SW7 pressed!", CR    
'        EndIf     

        ' The events must to be clear by the user (bit by bit) after read it.
        ' Using the falling edge of the buttons. (see the schematic)
        ' Resistors pull-up to VDD
        If SW0_Fedge = 1 Then                   ' Clear the bit when it is already read.
            SW0_Fedge = 0                       
            HRSOut "Falling Detect SW0", CR
            Toggle LED0                         ' Toggle the LED0 every time the SW0 is pressed.
            If LED0 = 1 Then
                HRSOut "LED0 ON", CR
            Else
                HRSOut "LED0 OFF", CR
            EndIf
            HRSOut CR
        EndIf

        If SW1_Fedge = 1 Then                   ' Clear the bit when it is already read.
            SW1_Fedge = 0
            HRSOut "Falling Detect SW1", CR
            Toggle LED1                         ' Toggle the LED1 every time the SW1 is pressed.
            If LED1 = 1 Then
                HRSOut "LED1 ON", CR
            Else
                HRSOut "LED1 OFF", CR
            EndIf
            HRSOut CR
        EndIf            

        If SW2_Fedge = 1 Then                   ' Clear the bit when it is already read.
            SW2_Fedge = 0                       
            HRSOut "Falling Detect SW2", CR
            Toggle LED2                         ' Toggle the LED2 every time the SW2 is pressed.
            If LED2 = 1 Then
                HRSOut "LED2 ON", CR
            Else
                HRSOut "LED2 OFF", CR
            EndIf
            HRSOut CR
        EndIf

        If SW3_Fedge = 1 Then                   ' Clear the bit when it is already read.
            SW3_Fedge = 0                       
            HRSOut "Falling Detect SW3", CR
            Toggle LED3                         ' Toggle the LED3 every time the SW3 is pressed.
            If LED3 = 1 Then
                HRSOut "LED3 ON", CR
            Else
                HRSOut "LED3 OFF", CR
            EndIf
            HRSOut CR
        EndIf            

        ' The events must to be clear by the user (bit by bit) after read it.
        ' Using the rising edge of the buttons. (see the schematic)
        ' Resistors pull-up to VSS
        If SW4_Redge = 1 Then                   ' Clear the bit when it is already read.
            SW4_Redge = 0
            HRSOut "Rising Detect SW4", CR
            Toggle LED4                         ' Toggle the LED3 every time the SW4 is pressed.
            If LED4 = 1 Then
                HRSOut "LED4 ON", CR
            Else
                HRSOut "LED4 OFF", CR
            EndIf
            HRSOut CR
        EndIf            

        If SW5_Redge = 1 Then                   ' Clear the bit when it is already read.
            SW5_Redge = 0
            HRSOut "Rising Detect SW5", CR
            Toggle LED5                         ' Toggle the LED3 every time the SW5 is pressed.
            If LED5 = 1 Then
                HRSOut "LED5 ON", CR
            Else
                HRSOut "LED5 OFF", CR
            EndIf
            HRSOut CR
        EndIf

        If SW6_Redge = 1 Then                   ' Clear the bit when it is already read.
            SW6_Redge = 0
            HRSOut "Rising Detect SW6", CR
            Toggle LED6                         ' Toggle the LED3 every time the SW6 is pressed.
            If LED6 = 1 Then
                HRSOut "LED6 ON", CR
            Else
                HRSOut "LED6 OFF", CR
            EndIf
            HRSOut CR
        EndIf            

        If SW7_Redge = 1 Then                   ' Clear the bit when it is already read.
            SW7_Redge = 0
            HRSOut "Rising Detect SW7", CR
            Toggle LED7                         ' Toggle the LED3 every time the SW7 is pressed.
            If LED7 = 1 Then
                HRSOut "LED7 ON", CR
                ClearWDTCounter()
                HRSOut "WATCHOG COUNTER CLEARED", CR
            Else
                HRSOut "LED7 OFF", CR
            EndIf
            HRSOut CR
        EndIf                                    

        MyDelayMS(100)                          ' 100mS delay. The Delay must be multiple of 4mS.
    Wend
'===============================================================================
    Stop
'=============================================================================== 
'-------------------------------------------------------------------------------
$ifdef _HRSOutVersionFile_inc_
_Test1_WatchdogInt_bas_Version_: CData "Test1_WatchdogInt.bas Version 1.0 - 14/05/2016",0
$endif
'-------------------------------------------------------------------------------
'===============================================================================


