'****************************************************************
'*  Name    : VersionFile.inc                                   *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 17/01/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : Send a String to the Terminal containing the      *
'*          : file version of any library                       *
'****************************************************************

$ifndef _HRSOutVersionFile_inc_
$define _HRSOutVersionFile_inc_

    GoTo OverHRSOutVersionFile
'===============================================================================
' Definition of local Words
$ifndef _LVWS_Block1_
    $define _LVWS_Block1_
    Dim LVSWord1 As Word System     ' Local Variable System Word1
    Dim LVSWord2 As Word System     ' Local Variable System Word2
$endif

'===============================================================================
' Function Name     : Print version File To the Terminal
' Author            : [Alberto Freixanet]
' Date              : 11/08/2013
' Routine Number    : AML68 : Versin 1.0
' Input Variables   : none
' Output Variables  : none
' Syntax            : HRSOutVersionFile(LABEL)
' Notes             : Print the String To the Terminal defined in LABEL written with CData
' Example:          : Note the powerfull command Hrsout Cstr. See manual page 180.
' LABEL: CData "AmicusMacros_17.inc Version 1.7-11/08/2013",0
' Using the Preprocessor commands: see the Amicus18 Compiler Manual page 365.
'
'$ifdef _HRSOutVersionFile_

    ' Using a local Word variable
    Dim StrgAddress As LVSWord1  ' Address of String of Cdata
    
$define HRSOutVersionFile(pValue)  _mHrsoutVFile pValue

_mHrsoutVFile Macro pValue
    #if (Prm_Count !=  1)
    	#error "_mHrsoutVFile - Should have one parameter (LABEL)"
        Exitm
    #else
		#if (Prm_1 != Label)
			#error "_mHrsoutVFile - (Param 1) should be a pointer to a LABEL"
		    Exitm
        #else
			Num_Word pValue, StrgAddress
		#endif
		GoSub _mHrsoutVFile_Sub
	#endif
Endm

#ifMacro- _mHrsoutVFile
_mHrsoutVFile_Sub:
    HRSOut CStr StrgAddress,CR
    Return
#endIfMacro-
'-------------------------------------------------------------------------------
OverHRSOutVersionFile:
$endif
'===============================================================================
